/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
package org.openmuc.jsml.structures;

import java.io.DataOutputStream;
import java.io.IOException;

public abstract class Choice extends ASNObject {

    /**
     * tag defines the type of the choice object
     */
    protected Unsigned8 tag;
    /**
     * data of the choice-object
     */
    protected ASNObject choice;

    public Choice() {
        tag = new Unsigned8();
    }

    @Override
    public void encode(DataOutputStream os) throws IOException {
        if (isOptional && !isSelected) {
            os.writeByte(0x01);
            return;
        }
        os.writeByte(0x72);
        tag.encode(os);
        choice.encode(os);
    }

    public ASNObject getChoice() {
        return choice;
    }

    public Unsigned8 getTag() {
        return tag;
    }
}
