/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
package org.openmuc.jsml.test.structures;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import org.junit.Assert;
import org.junit.Test;
import org.openmuc.jsml.structures.ListOfSmlTree;
import org.openmuc.jsml.structures.OctetString;
import org.openmuc.jsml.structures.SmlTree;

public class EncodingDecodingTest {

    @Test
    public void encodeListOfSMLTreeWithManyElements() {
        ByteArrayOutputStream bs = new ByteArrayOutputStream(50);
        DataOutputStream os = new DataOutputStream(bs);
        SmlTree[] sml_Trees = new SmlTree[25];
        for (int i = 0; i < 25; i++) {
            sml_Trees[i] = new SmlTree(new OctetString("test"), null, null);
        }
        ListOfSmlTree list_of_SML_Tree = new ListOfSmlTree(sml_Trees);

        try {
            list_of_SML_Tree.encode(os);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        Assert.assertEquals(bs.toByteArray()[0], (byte) 0xf1);
        Assert.assertEquals(bs.toByteArray()[1], (byte) 0x09);

    }

}
